﻿Public Class frmEvaluation
    Private Sub frmEvaluation_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        cbMonth.Text = "Dezember"
        cbYear.Text = "2019"
    End Sub
    Private Sub btnFillList_Click(sender As Object, e As EventArgs) Handles btnFillList.Click
        If cbMonth.Text <> "" AndAlso cbYear.Text <> "" Then FillList()
    End Sub

    Private Sub FillList()
        'Liste löschen
        With DGVEvaluation
            .Rows.Clear()
            For i As Integer = .ColumnCount - 1 To 0 Step -1
                .Columns.RemoveAt(i)
            Next i
        End With
        With DGVEvaluationTotal
            .Rows.Clear()
            For i As Integer = .ColumnCount - 1 To 0 Step -1
                .Columns.RemoveAt(i)
            Next i
        End With
        'Anzahl der Warengruppen ermitteln
        Dim GroupCount As Integer
        GroupCount = DSIncome.ProductGroup.Count
        'erste Spalte für Datumswerte anlegen
        DGVEvaluation.Columns.Add("clmDate", "Datum")
        Dim Groupname As String
        'entsprechend Spalten anlegen
        For i = 0 To GroupCount - 1
            'Name aus BindingSource lesen
            Dim ProductGroup = DirectCast(DirectCast(ProductGroupBindingSource(i), DataRowView).Row, DSIncome.ProductGroupRow)
            Groupname = ProductGroup.Name
            'Spalte für jede Warengruppe anlegen
            DGVEvaluation.Columns.Add("clm" & Groupname, Groupname)
        Next
        'Spalten für Tageseinnahme und Kunden anlegen
        With DGVEvaluation
            .Columns.Add("clmTotalIncome", "gesamt")
            .Columns.Add("clmCustomers", "Kunden")
        End With
        'DGV Spalten formatieren

        'TODO formatierung      ####################################################################
        Dim DGVColumnCount As Integer = DGVEvaluation.ColumnCount
        DGVEvaluation.DefaultCellStyle.Font = New Font("Microsoft Sans Serif", 12)
        For L = 1 To DGVColumnCount - 2
            With DGVEvaluation.Columns(L)
                .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
                .SortMode = DataGridViewColumnSortMode.NotSortable
            End With
        Next
        With DGVEvaluation.Columns(0)
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
            .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
            .SortMode = DataGridViewColumnSortMode.NotSortable
        End With
        With DGVEvaluation.Columns(DGVColumnCount - 1)
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
            .SortMode = DataGridViewColumnSortMode.NotSortable
        End With
        'DGV Header formatieren
        DGVEvaluation.RowHeadersVisible = False
        With DGVEvaluation.ColumnHeadersDefaultCellStyle
            .Alignment = DataGridViewContentAlignment.MiddleCenter
            .Font = New Font("Microsoft Sans Serif", 12)
        End With
        ' #################################################################################################
        'Start und Enddatum aus Comboboxen ermitteln
        Dim StartDate As Date
        Dim EndDate As Date
        Dim Numberofdays As Integer
        Dim CompareDate As Date
        Dim NumberofdaysLastYear As Integer
        If Not GetDates(StartDate, EndDate, Numberofdays, CompareDate, NumberofdaysLastYear) Then
            MessageBox.Show("ungültige Datumsauswahl")
            Exit Sub
        End If

        'Schleife durch jeden Tag des Monats
        Dim TempDate As Date
        Dim indexcounter As Integer = -1
        Dim ArrGroupIncome(0 To GroupCount - 1) As Double
        Dim Totalincome As Double
        Dim Dailyincome As Double
        Dim TotalCustomers As Integer
        Dim DailyCustomers As Integer
        For i = 0 To Numberofdays - 1
            'Datum um einen Tag erhöhen
            TempDate = StartDate.AddDays(i)
            'Datum in den Einnahmen suchen
            Dim IncomeRow = DSIncome.DailyIncome.FirstOrDefault(Function(x) x._Date.Date = TempDate)
            If IncomeRow Is Nothing Then Continue For   'Wenn nicht gefunden, nächster Durchgang
            'Wenn gefunden: Datum in Listview schreiben
            DGVEvaluation.Rows.Add(IncomeRow._Date.ToString("ddd dd.MM"))
            indexcounter += 1
            'und Warengruppeneinnahmen aus DTS pulen
            For j = 0 To GroupCount - 1         'Schleife durch Product Group DataTable
                'Name aus BindingSource lesen
                Dim ProductGroup = DirectCast(DirectCast(ProductGroupBindingSource(j), DataRowView).Row, DSIncome.ProductGroupRow)
                Groupname = ProductGroup.Name
                'Warengruppenumsatz für Datum ermitteln und in Listview eintragen
                Dim ProductGroupRow = DSIncome.DistributionTable.SingleOrDefault(Function(x) x.DailyIncomeRow._Date.Date = TempDate AndAlso x.ProductGroupRow.Name = Groupname)
                If ProductGroupRow Is Nothing Then Continue For
                Dim Income As Double
                Income = CDbl(ProductGroupRow.ProductGroupIncome / 100)
                DGVEvaluation.Rows(indexcounter).Cells(j + 1).Value = Income.ToString("#,##0.00")
                'Umsatz in Array addieren
                ArrGroupIncome(j) += Income
            Next
            'Tagesumsatz (gesamt) und Kunden eintragen und Gesamtzahlen errechnen
            Dailyincome = CDbl(IncomeRow.DailyTakings / 100)
            DGVEvaluation.Rows(indexcounter).Cells(DGVColumnCount - 2).Value = Dailyincome.ToString("#,##0.00")
            Totalincome += Dailyincome
            DailyCustomers = IncomeRow.CustomerCount
            DGVEvaluation.Rows(indexcounter).Cells(DGVColumnCount - 1).Value = DailyCustomers.ToString
            TotalCustomers += DailyCustomers
        Next

        'DGV für gesamtUmsätze formatieren
        DGVEvaluationTotal.Columns.Add("clm1", "")
        For i = 0 To GroupCount - 1
            'Name aus BindingSource lesen
            Dim ProductGroup = DirectCast(DirectCast(ProductGroupBindingSource(i), DataRowView).Row, DSIncome.ProductGroupRow)
            Groupname = ProductGroup.Name
            'Spalte für jede Warengruppe anlegen
            DGVEvaluationTotal.Columns.Add("clm" & Groupname, Groupname)
        Next
        'Spalten für Tageseinnahme und Kunden anlegen
        With DGVEvaluationTotal
            .Columns.Add("clmTotalIncome", "gesamt")
            .Columns.Add("clmCustomers", "Kunden")
        End With
        'DGV Spalten formatieren
        DGVEvaluationTotal.DefaultCellStyle.Font = New Font("Microsoft Sans Serif", 12)
        For L = 1 To DGVColumnCount - 2
            With DGVEvaluationTotal.Columns(L)
                .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
            End With
        Next
        With DGVEvaluationTotal.Columns(0)
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells
        End With
        With DGVEvaluationTotal.Columns(DGVColumnCount - 1)
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
        End With
        'DGV Header formatieren
        DGVEvaluationTotal.RowHeadersVisible = False
        With DGVEvaluationTotal.ColumnHeadersDefaultCellStyle
            .Alignment = DataGridViewContentAlignment.MiddleCenter
            .Font = New Font("Microsoft Sans Serif", 12)
        End With
        'Zeile für Gesamtumsätze anlegen
        DGVEvaluationTotal.Rows.Add("gesamt")
        'Gesamtumsätze für jede Warengruppe eintragen
        For k = 0 To GroupCount - 1
            DGVEvaluationTotal.Rows(0).Cells(k + 1).Value = ArrGroupIncome(k).ToString("#,##0.00")
        Next
        'Gesamtumsatz Tage eintragen
        DGVEvaluationTotal.Rows(0).Cells(DGVColumnCount - 2).Value = Totalincome.ToString("#,##0.00")
        'Gesamtkunden eintragen
        DGVEvaluationTotal.Rows(0).Cells(DGVColumnCount - 1).Value = TotalCustomers.ToString

        'Umsätze aus Vergleichsjahr suchen
        Dim ArrGroupIncomeComp(0 To GroupCount - 1) As Double
        Dim TotalIncomeComp As Double
        Dim TotalCustomersComp As Integer
        For i = 0 To NumberofdaysLastYear - 1
            'Datum um einen Tag erhöhen
            TempDate = CompareDate.AddDays(i)
            'Datum in den Einnahmen suchen
            Dim IncomeRow = DSIncome.DailyIncome.FirstOrDefault(Function(x) x._Date.Date = TempDate)
            If IncomeRow Is Nothing Then Continue For   'Wenn nicht gefunden, nächster Durchgang
            'Warengruppeneinnahmen aus DTS pulen
            For j = 0 To GroupCount - 1         'Schleife durch Product Group DataTable
                'Name aus BindingSource lesen
                Dim ProductGroup = DirectCast(DirectCast(ProductGroupBindingSource(j), DataRowView).Row, DSIncome.ProductGroupRow)
                Groupname = ProductGroup.Name
                'Warengruppenumsatz für Datum ermitteln
                Dim ProductGroupRow = DSIncome.DistributionTable.SingleOrDefault(Function(x) x.DailyIncomeRow._Date.Date = TempDate AndAlso x.ProductGroupRow.Name = Groupname)
                If ProductGroupRow Is Nothing Then Continue For
                Dim Income As Double
                Income = CDbl(ProductGroupRow.ProductGroupIncome / 100)
                DGVEvaluation.Rows(indexcounter).Cells(j + 1).Value = Income.ToString("#,##0.00")
                'Umsatz in Array addieren
                ArrGroupIncomeComp(j) += Income
            Next
            'Tagesumsatz (gesamt) und Kunden eintragen und Gesamtzahlen errechnen
            Dailyincome = CDbl(IncomeRow.DailyTakings / 100)
            TotalIncomeComp += Dailyincome
            DailyCustomers = IncomeRow.CustomerCount
            TotalCustomersComp += DailyCustomers
        Next
        'Zeile für Umsätze aus Vergleichsjahr anlegen
        DGVEvaluationTotal.Rows.Add(CompareDate.ToString("yyyy"))
        'Gesamtumsätze für jede Warengruppe eintragen
        For k = 0 To GroupCount - 1
            DGVEvaluationTotal.Rows(1).Cells(k + 1).Value = ArrGroupIncomeComp(k).ToString("#,##0.00")
        Next
        'Gesamtumsatz Tage eintragen
        DGVEvaluationTotal.Rows(1).Cells(DGVColumnCount - 2).Value = TotalIncomeComp.ToString("#,##0.00")
        'Gesamtkunden eintragen
        DGVEvaluationTotal.Rows(1).Cells(DGVColumnCount - 1).Value = TotalCustomersComp.ToString

        'Zeile für Vergleichen anlegen
        DGVEvaluationTotal.Rows.Add("%")
        '& für jede Warengruppe eintragen
        For k = 0 To GroupCount - 1
            DGVEvaluationTotal.Rows(2).Cells(k + 1).Value = Math.Round(ArrGroupIncomeComp(k) * 100 / ArrGroupIncome(k), 2).ToString("0.00") & " %"
        Next
        '% für Tagesumsatz eintragen
        DGVEvaluationTotal.Rows(2).Cells(DGVColumnCount - 2).Value = Math.Round(TotalIncomeComp * 100 / Totalincome, 2).ToString("0.00") & " %"
        '% für Kunden eintragen
        Dim Customercompare As Double = Math.Round(TotalCustomersComp * 100 / TotalCustomers, 2)
        DGVEvaluationTotal.Rows(2).Cells(DGVColumnCount - 1).Value = Customercompare.ToString("0.00") & " %"
        If Customercompare > 100 Then
            With DGVEvaluationTotal
                .Rows(2).Cells(DGVColumnCount - 1).Style.ForeColor = Color.Blue
                .Rows(2).Cells(DGVColumnCount - 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
                .Rows(0).Cells(DGVColumnCount - 1).Style.ForeColor = Color.Blue
                .Rows(0).Cells(DGVColumnCount - 1).Style.Font = New Font("Microsoft Sans Serif", 12, FontStyle.Bold)
            End With
        End If




        'DGV Größe ändern                                                                       ##########################
        Dim width As Integer = 30
        Dim Height As Integer = 20
        For i = 0 To DGVColumnCount - 1
            width += DGVEvaluation.Columns(i).Width
        Next
        width += DGVEvaluation.RowHeadersWidth
        For i = 0 To DGVEvaluation.Rows.Count - 1
            Height += DGVEvaluation.Rows(i).Height
        Next
        Height += DGVEvaluation.ColumnHeadersHeight
        DGVEvaluation.Width = width
        DGVEvaluation.Height = Height
    End Sub
    Private Function GetDates(ByRef Startdate As Date, ByRef EndDate As Date, ByRef Numberofdays As Integer, ByRef comparedate As Date, ByRef NumberofdaysLastYear As Integer) As Boolean
        Dim strMonth As String = cbMonth.Text
        Dim year As Integer
        Dim compyear As Integer
        'Prüfen ob cbyear numerisc ist
        If Not Integer.TryParse(cbYear.Text, year) Then
            Return False
        End If
        'Prüfen ob cbcompyear numerisc ist
        If Not Integer.TryParse(cbCompare.Text, compyear) Then
            Return False
        End If

        Dim Month As Integer
        Select Case strMonth
            Case = "Januar" : Month = 1
            Case = "Februar" : Month = 2
            Case = "März" : Month = 3
            Case = "April" : Month = 4
            Case = "Mai" : Month = 5
            Case = "Juni" : Month = 6
            Case = "Juli" : Month = 7
            Case = "August" : Month = 8
            Case = "September" : Month = 9
            Case = "Oktober" : Month = 10
            Case = "November" : Month = 11
            Case = "Dezember" : Month = 12
            Case Else
                Return False
        End Select
        Startdate = Date.Parse("01." & Month & "." & year)
        Numberofdays = Integer.Parse(DateTime.DaysInMonth(year, Month).ToString)
        EndDate = Startdate.AddDays(Numberofdays - 1)
        comparedate = Date.Parse("01." & Month & "." & compyear)
        NumberofdaysLastYear = Integer.Parse(DateTime.DaysInMonth(compyear, Month).ToString)
        Return True

    End Function

    Private Sub cbYear_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cbYear.SelectedIndexChanged
        cbCompare.Text = (Integer.Parse(cbYear.Text) - 1).ToString
    End Sub
End Class