﻿Public Class frmNewIncome
    Dim TBList As New List(Of Control)

#Region "Form Load"
    Private Sub frmNewIncome_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dtpIncomeDate.Value = System.DateTime.Now
        DrawControls()
        GetIncome()
    End Sub
    Private Sub frmNewIncome_Paint(sender As Object, e As PaintEventArgs) Handles Me.Paint
        e.Graphics.DrawLine(Pens.Black, 0, 150, 749, 150)
    End Sub

    Private Sub DrawControls()
        'Anzahl der Warengruppen ermitteln
        Dim GroupCount As Integer
        GroupCount = DSIncome.ProductGroup.Count
        'abbrechen, wenn es keine Warengruppen gibt
        If GroupCount = 0 Then
            MessageBox.Show("Eitragen nicht möglich. - keine Warengruppen gespeichert.")
            Exit Sub
        End If
        Dim GroupName As String
        Dim yPosition As Integer = 175
        Dim xPosition As Integer = 12
        'Controls für jede Warengruppe erzeugen
        For i = 1 To GroupCount
            'Name aus BindingSource lesen
            Dim ProductGroup = DirectCast(DirectCast(ProductGroupBindingSource(i - 1), DataRowView).Row, DSIncome.ProductGroupRow)
            GroupName = ProductGroup.Name

            'Label
            Dim NewLBL = New System.Windows.Forms.Label
            With NewLBL
                .Location = New System.Drawing.Point(xPosition, yPosition)
                .Font = New Font("Microsoft Sans Serif", 12)
                .TextAlign = ContentAlignment.MiddleCenter
                .Name = "LBL " & GroupName
                .Size = New System.Drawing.Size(200, 20)
                .Text = GroupName
                .Visible = True
            End With

            'TextBox
            Dim newTB = New System.Windows.Forms.TextBox
            With newTB
                .Location = New System.Drawing.Point(xPosition, yPosition + 23)
                .Font = New Font("Microsoft Sans Serif", 12)
                .Name = "TB " & GroupName
                .Size = New System.Drawing.Size(200, 26)
                .TabIndex = 3 + i
                .Visible = True
                AddHandler .TextChanged, AddressOf TextChangeEvent
            End With
            TBList.Add(newTB)

            'Controls auf die Form malen
            Me.Controls.Add(NewLBL)
            Me.Controls.Add(newTB)

            xPosition += 250
            If xPosition > 532 Then
                xPosition = 12
                yPosition += 70
            End If

        Next

        Me.Height = yPosition + 140
    End Sub
#End Region

#Region "Change Events"
    Private Sub dtpIncomeDate_ValueChanged(sender As Object, e As EventArgs) Handles dtpIncomeDate.ValueChanged
        GetIncome()
    End Sub
    'Text Change Event der codeerzeugten Textboxen
    Private Sub TextChangeEvent(sender As Object, e As EventArgs)
        Dim TBContent As String
        Dim TotalIncome As Double = 0
        Dim Income As Double
        For Each TB As Control In TBList 'Schleife durch alle codeerzeugten Textboxen
            TBContent = TB.Text
            If TBContent = "" Then TBContent = 0.ToString
            If Not Double.TryParse(TBContent, Income) Then
                tbDailyIncome.Text = ""
                Exit Sub
            End If
            TotalIncome += Income
            tbDailyIncome.Text = TotalIncome.ToString
        Next
    End Sub

#End Region

#Region "Button Klick Events"
    Private Sub btnDateMinus_Click(sender As Object, e As EventArgs) Handles btnDateMinus.Click
        SetNewDate(-1)
    End Sub

    Private Sub btnDatePlus_Click(sender As Object, e As EventArgs) Handles btnDatePlus.Click
        SetNewDate(1)
    End Sub

    Private Sub btnCancel_Click(sender As Object, e As EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub
    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        SaveIncome()
    End Sub
#End Region

#Region "Subs und Funktionen"
    Private Sub GetIncome()
        Dim IncomeDate As Date = Date.Parse(dtpIncomeDate.Value.ToString("dd.MM.yyyy"))

        'Textboxen leeren
        For Each TB As Control In TBList
            TB.Text = ""
        Next
        tbCustomers.Text = ""
        tbDailyIncome.Text = ""

        'prüfen ob Datum bereits existiert
        Dim IncomeRow = DSIncome.DailyIncome.FirstOrDefault(Function(x) x._Date.Date = IncomeDate)
        If IncomeRow Is Nothing Then Return
        tbCustomers.Text = IncomeRow.CustomerCount.ToString
        tbDailyIncome.Text = (IncomeRow.DailyTakings / 100).ToString
        Incomedate = IncomeRow._Date

        'Schleife durch ListOf(TB), zum laden der Warengruppeneinnahmen
        For Each TB As Control In TBList
            Dim Groupname As String = TB.Name.Substring(3)
            Dim ProductGroupRow = DSIncome.DistributionTable.SingleOrDefault(Function(x) x.DailyIncomeRow._Date.Date = IncomeDate AndAlso x.ProductGroupRow.Name = Groupname)
            If ProductGroupRow Is Nothing Then Return
            TB.Text = (ProductGroupRow.ProductGroupIncome / 100).ToString
        Next
    End Sub
    Private Sub SetNewDate(DateChange As Integer)
        If dtpIncomeDate.Value.AddDays(DateChange).DayOfWeek = 0 Then
            dtpIncomeDate.Value = dtpIncomeDate.Value.AddDays(DateChange * 2)
        Else
            dtpIncomeDate.Value = dtpIncomeDate.Value.AddDays(DateChange)
        End If
    End Sub

    Private Sub SaveIncome()

        'Validierung der Daten
        If Not Validation() Then Exit Sub

        'prüfen ob Datum bereits existiert
        Dim IncomeRow = DSIncome.DailyIncome.FirstOrDefault(Function(x) x._Date.Date = dtpIncomeDate.Value.Date)
        Dim IncomeDate As Date = Date.Parse(dtpIncomeDate.Value.ToString("dd.MM.yyyy"))
        If IncomeRow Is Nothing Then        'Eintrag speichern
            'neue Tageseinnahme anlegen
            Dim newIncome As DSIncome.DailyIncomeRow
            newIncome = DSIncome.DailyIncome.NewDailyIncomeRow()
            Dim IncomeID As Integer = newIncome.ID
            With newIncome
                ._Date = IncomeDate
                .CustomerCount = Integer.Parse(tbCustomers.Text)
                .DailyTakings = CInt(Double.Parse(tbDailyIncome.Text) * 100)
            End With
            DSIncome.DailyIncome.Rows.Add(newIncome)

            'Warengruppenumsatz eintragen
            Dim ProductGroupIncome As Integer
            Dim ProductGroupID As Integer
            For Each TB As Control In TBList
                ProductGroupIncome = CInt(Double.Parse(TB.Text) * 100)
                'Warengruppe im DataSet suchen     
                Dim ProductGroup = DSIncome.ProductGroup
                For Each row In ProductGroup
                    If "TB " & row.Name = TB.Name Then
                        ProductGroupID = row.ID
                        Exit For
                    End If
                Next

                'neue Zeile in DistributionTable anlegen
                Dim newDistributionRow As DSIncome.DistributionTableRow
                newDistributionRow = DSIncome.DistributionTable.NewDistributionTableRow()
                With newDistributionRow
                    .ProductGroupID = ProductGroupID
                    .DailyIncomeID = IncomeID
                    .ProductGroupIncome = ProductGroupIncome
                End With
                DSIncome.DistributionTable.Rows.Add(newDistributionRow)
            Next
        Else        'Eintrag ändern
            'Tageseinnahme und Kunden speichern
            IncomeRow.CustomerCount = Integer.Parse(tbCustomers.Text)
            IncomeRow.DailyTakings = CInt(Double.Parse(tbDailyIncome.Text) * 100)

            'Schleife durch ListOf(TB), zum laden der Warengruppeneinnahmen
            For Each TB As Control In TBList
                Dim Groupname As String = TB.Name.Substring(3)
                Dim ProductGroupRow = DSIncome.DistributionTable.SingleOrDefault(Function(x) x.DailyIncomeRow._Date.Date = IncomeDate AndAlso x.ProductGroupRow.Name = Groupname)
                If ProductGroupRow Is Nothing Then Return
                ProductGroupRow.ProductGroupIncome = CInt(Double.Parse(TB.Text) * 100)
            Next
        End If

        If Not cbxMultipleEntries.Checked Then Me.Close()

    End Sub

    Private Function Validation() As Boolean
        Dim TempVar As Double
        If Not Double.TryParse(tbCustomers.Text, TempVar) Then
            MessageBox.Show("Kundenzahl ungültig")
            Return False
        End If
        If Not Double.TryParse(tbDailyIncome.Text, TempVar) Then
            MessageBox.Show("Tageseinnahme ungültig")
            Return False
        End If
        For Each TB As Control In TBList
            If TB.Text = "" Then
                TB.Text = 0.ToString
            Else
                If Not Double.TryParse(TB.Text, TempVar) Then
                    MessageBox.Show(TB.Name.Substring(3) & " Einnahme ungültig")
                    Return False
                End If
            End If
        Next
        Return True
    End Function

#End Region

End Class